#
# Imports
#
import sys
from coopr.pyomo import *


#
# Setup
#

model = Model()

model.PROD = Set()

model.rate = Param(model.PROD,within=PositiveReals)

model.avail = Param(within=PositiveReals) 

model.profit = Param(model.PROD)
model.market = Param(model.PROD, within=PositiveReals)

def Make_bounds(i,model):
    return (0,model.market[i])
model.Make = Var(model.PROD, bounds=Make_bounds)

# Max profit
def Objective_rule(model):
    ans = 0
    for p in model.PROD:
        ans = ans + model.profit[p] * model.Make[p]
    return ans
#profit v totalprofit
model.totalprofit = Objective(rule=Objective_rule, sense=maximize)

# Subj to time
def Time_rule(model):
    ans = 0
    for p in model.PROD:
      ans = ans + (1.0/model.rate[p]) * model.Make[p]
    return ans < model.avail
model.Time = Constraint(rule=Time_rule)
