#
# Imports
#
import sys
from coopr.pyomo import *

#
# Setup
#

model = Model()

model.PROD = Set()
model.STAGE = Set()

model.rate = Param(model.PROD,model.STAGE,within=PositiveReals)

model.avail = Param(model.STAGE, within=PositiveReals)

model.profit = Param(model.PROD)

model.commit = Param(model.PROD, within=PositiveReals)

model.market = Param(model.PROD, within=PositiveReals)

def Make_bounds(i,model):
    return (model.commit[i],model.market[i])
model.Make = Var(model.PROD, bounds=Make_bounds)

def Objective_rule (model):
    ans = 0
    for p in model.PROD:
        ans = ans + model.profit[p] * model.Make[p]
    return ans
model.totalprofit = Objective(rule=Objective_rule, sense=maximize)

#Subj to time

#************************ new problem - 
#subject to Time {s in STAGE}:
#def Time_rule(model):
#    ans = 0
#    for p in model.PROD:
#        ans = ans + (1.0/model.rate[p] * model.Make[p])
#        return ans < model.market
#model.avail = Constraint(rule=Time_rule)

def Timelim_rule(s, model):
    timeexpr = 0
    for p in model.PROD:
        timeexpr = timeexpr + (1.0/model.rate[p,s]) * model.Make[p]
    return timeexpr < model.avail[s]
model.Time = Constraint(model.STAGE, rule=Timelim_rule)

